<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Bootstrap flex</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
</head>
<body>
    <div class="container-fluid bg-dark text-center text-light">Bootstrap flexbox</div>
    <h1>BootStrap Flex</h1>
    <p>Use the d-flex class to create a flex container and transform direct children into flex items.</p>
    <!-- align-items-center - class will horizontally center all the child elements and it will only be accessible if the display is flex. -->
    <!-- justify-content-center it will vertically center  all the child elements and it will only be accessible if the display value is flex.-->
    <!-- d-flex - flex value will change the element into block-level container. it will make all the elements be come 'flexible' that allows them to occupy space
    enough for the content of an element and at the same time will have the elements appear beside each other. -->
    <h2>Flex Column</h2>
    <div style="height:500px" class="bg-dark d-flex flex-column p-3 align-items-center justify-content-center">
        <div class="p-3 bg-success col-2">Flex Item A</div>
        <div class="p-3 bg-warning col-4">Flex Item B</div>
        <div class="p-3 bg-danger col-2">Flex Item c</div>
    </div>

    <h2>Flex Row</h2>
    <div style="height: 300px;" class="bg-dark d-flex p-3 flex-row justify-content-center align-items-center">
        <div class="p-3 bg-success ">Flex Item A</div>
        <div class="p-3 bg-warning ">Flex Item B</div>
        <div class="p-3 bg-danger ">Flex Item c</div>
    </div>

    

    <h2>Flex Row Reverse</h2>
    <div class="bg-dark d-flex p-3 flex-row-reverse align-items-center">
        <div class="p-3 bg-success ">Flex Item A</div>
        <div class="p-3 bg-warning ">Flex Item B</div>
        <div class="p-3 bg-danger ">Flex Item c</div>
    </div>

    <h2>Create space between elements using justify-content-around</h2>
    <div  class="bg-dark d-flex p-3 flex-row justify-content-around ">
        <div class="p-3 bg-success ">Flex Item A</div>
        <div class="p-3 bg-warning ">Flex Item B</div>
        <div class="p-3 bg-danger ">Flex Item c</div>
    </div>

    <h2>Create space between elements using justify-content-between</h2>
    <div  class="bg-dark d-flex p-3 flex-row justify-content-between d-md-flex">
        <div class="p-3 bg-success ">Flex Item A</div>
        <div class="p-3 bg-warning ">Flex Item B</div>
        <div class="p-3 bg-danger ">Flex Item c</div>
    </div>

    <h2>Flexbox with margin</h2>
    <div  class="bg-dark p-3 d-flex flex-row">
        <div class="p-3 bg-success mr-auto">Flex Item A</div>
        <div class="p-3 bg-warning ">Flex Item B</div>
        <div class="p-3 bg-danger ">Flex Item c</div>
        <div class="p-3 bg-primary ml-auto ">Flex Item D</div>
    </div>

    <h2>Nested Flex Elements</h2>
    <div  class="bg-dark p-3 d-flex flex-row ">
        <div class="p-3 bg-success d-flex flex-row">Flex Item A</div>
            <div class="p-3 bg-warning justify-content-between d-flex flex-row w-50">Flex Item B
                <div class="p-3 bg-danger ">Flex Item c</div>
                <div class="p-3 bg-primary ">Flex Item D</div>
            </div>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
</body>
</html>